<TeXmacs|1.99.11>

<style|<tuple|tmdoc|octave|english|old-spacing>>

<\body>
  <tmdoc-title|Further details on the <name|Octave>X plug-in>

  <name|Octave>X is an evolution of the <name|Octave> plugins, with updated
  graphic compatibility (tested with <name|Octave> versions 4 to 5), the
  other parts being basically the same as the older plugin.

  <name|Octave> and <TeXmacs> communicate via a synchronous pipe interface.
  This allows the <name|Octave> console to be presented in a typeset region
  of a <TeXmacs> document. To display typeset materials in this <TeXmacs>
  region, <name|Octave> code can print escape sequences to transfer
  <name|Scheme>, <LaTeX>, or Postscript materials for display.\ 

  This <name|Octave> interface is implemented as a set of m-files for
  interacting with <TeXmacs> via <name|Scheme>. As of v1.0.1 <TeXmacs>
  includes the required interface code and should automagically detect the
  presense of <name|Octave> . These m-files generate <TeXmacs> content from
  <name|Octave> and perform related functions:

  <\indent>
    <with|color|blue|tmdisp.m> \ Displays an <name|Octave> variable
    "pretty-printed" via the <TeXmacs> interface. It supports scalar, matrix,
    structure, list and string types. You must use tmdisp, instead of disp,
    to get \ <TeXmacs> formatted variable output.

    <with|color|blue|polyout.m> \ Modified polynomial printer to use a
    <LaTeX> formula.

    <with|color|blue|scheme.m> \ Executes a string as a <name|Scheme>
    expression via <TeXmacs>.

    <with|color|blue|num2scm.m> Converts a number (scalar) to a <TeXmacs>
    <name|Scheme> expression.

    <with|color|blue|mat2scm.m> \ Converts a matrix to a <TeXmacs>
    <name|Scheme> expression.

    <with|color|blue|str2scm.m> \ Converts a string to a <TeXmacs>
    <name|Scheme> expression.

    <with|color|blue|struct2bullet.m> Converts a structure to a bulleted
    <TeXmacs> list.

    <with|color|blue|struct2tree.m> \ Converts a structure to a <TeXmacs>
    tree. The leaves of the tree are "switchable" and can be switched to the
    variable name or content for easy traversal of complicated <name|Octave>
    structures.\ 

    <with|color|blue|struct2scm.m> Converts a structure to a <TeXmacs>
    <name|Scheme> expression by calling either struct2bullet or struct2tree,
    depending on the user's configuration. The TMSTRUCT global <name|Octave>
    variable is used. If TMSTRUCT = 0 a tree is used, else a bulleted list is
    used.

    <with|color|blue|list2scm.m> \ Converts a list to a <TeXmacs>
    <name|Scheme> expression.\ 

    <with|color|blue|obj2scm.m> Front end interface to the other converters
    to convert an arbitrary <name|Octave> variable to a <TeXmacs>
    <name|Scheme> expression. In most cases, user programs should use this
    function.

    \;

    <name|Octave>X functions

    <with|color|blue|tmmod.m> User function. Changes the plugin behavior.
    Presently, only changing of the plotting mode is allowed. Possible modes
    are: <with|font-series|bold|normal> (figures are automatically inserted
    in the <TeXmacs> document when an octave plotting command is issued); or
    <with|font-series|bold|interactive> (octave figures remain open and can
    be modified, e.g. adding titles, legends etc. In this case, when the
    figure looks fine, use the tmfig command to close the octave figure
    window and insert the image in the <TeXmacs> document).

    <with|color|blue|tmfig.m> User function. This macro closes the octave
    figure window and import the image in the <TeXmacs> document. Valid only
    in interactive plotting mode.

    <with|color|blue|tmgt.m> User function. Set a default graphics toolkit
    that will be loaded by <name|Octave> at the next <TeXmacs> restart. Valid
    options are: <em|'none'>, <em|'gnuplot'>, <em|'fltk'>, <em|'qt'> - or
    shortened - <em|'0'>, <em|'g'>,<em|'f'>,<em|'q'> (all with quotes).

    <with|color|blue|tmrepl.m> Internal function (called by the plugin),
    modified to load graphic windows in the <TeXmacs> document.

    <with|color|blue|_tm_oct_.m> Internal function (called by the plugin),
    takes care of the actual image loading in <TeXmacs> and of the
    <name|Octave> plotting windows management.

    \;
  </indent>

  \ 

  The appearance of the <TeXmacs> output, namely the colors used, can be
  customized by setting the appropriate <name|Octave> global variables. These
  global variables should be defined in your ~/.octaverc or in the
  system-wide octaverc:

  <\indent>
    <\code>
      <\with|par-par-sep|0fn>
        global TMSTRUCT=0; ## Use tree output for structures.

        global TMCOLORS=["black"; "red"; "magenta"; "orange"; "green";
        "blue";];

        global TMCOLIDX=6; ## number of colors
      </with>
    </code>
  </indent>

  The TMCOLORS array lists the available colors, in order, to be used by
  struct2bullet.m it will change to each color in turn as it indents the
  bulleted list. Additionally, the first color in the list is used as the
  color for the leaves of struct2tree.m output.\ 

  <tmdoc-copyright|2011|Michael Graffam|Joris van der Hoeven>

  <tmdoc-license|Permission is granted to copy, distribute and/or modify this
  document under the terms of the GNU Free Documentation License, Version 1.1
  or any later version published by the Free Software Foundation; with no
  Invariant Sections, with no Front-Cover Texts, and with no Back-Cover
  Texts. A copy of the license is included in the section entitled "GNU Free
  Documentation License".>
</body>

<initial|<\collection>
</collection>>