## This software falls under the GNU general public license version 3 or later.
## It comes WITHOUT ANY WARRANTY WHATSOEVER. For details, see the file LICENSE
## in the root directory or <http://www.gnu.org/licenses/gpl-3.0.html>
## Aug. 2018 --  TeXmacs plotting interface --
## tested with octave 4.2.1, 4.4.0, 4.4.1, 5.1.0
## Author: Lorenzo Lunelli
## partly based on code from old TeXmacs plotting interface - Jan. 2003 -- Author: Michael Graffam
## v 0.5 Aug 2018
## v 0.6 Nov 2019 - added Windows compatibility, added plot windows visibility, switched form sleep (obsolete) to pause

function dum = _tm_oct_ ()
## ------------------- TeXmacs Interface --------------------
	# Lorenzo - 21-08-2018 - check if interactive plotting mode is selected
	# Lorenzo - 1-11-2019 - added checks on figure visibility
	# Lorenzo - 2-11-2019 - added check for empty figures
	# Lorenzo - 3 to 7-11-2019 - added: windows compatibility, switched form sleep (obsolete) to pause
	global TEXMACS_OCTAVE_PLUGIN_CONTROL; # 28-August 2018: now using global variables - 1 Sept 2018: new name
	global TEXMACS_OCTAVE_TMP; # 3-11-2019 added for windows compatibility
	h = gcf ();
	if (bitget(TEXMACS_OCTAVE_PLUGIN_CONTROL,2)==0)   # check bit 2 state (figure visibility off)
		set (h,"visible","off");
	endif
	if (bitget(TEXMACS_OCTAVE_PLUGIN_CONTROL,2)==1)   # check bit 2 state (figure visibility on)
		set (h,"visible","on");
	endif
	if (sizeof(get (h,"currentaxes"))!=0)  # there is a figure with a plot
		if (bitget(TEXMACS_OCTAVE_PLUGIN_CONTROL,1)==1)   # check bit 1 state (plotting mode): interactive mode, only show the figure
			pause (0.1);	 # this seems to be necessary on Linux
			refresh (h);
			refresh (h); # Cygwin: this seems to be necessary to update the image (the same behavior happens in octave)
		endif
		if (bitget(TEXMACS_OCTAVE_PLUGIN_CONTROL,1)==0)   # check bit 1 state 	# normal mode, load the data in TeXmacs
			print(h,TEXMACS_OCTAVE_TMP, "-deps", "-color");
			clf(h);
			if (bitget(TEXMACS_OCTAVE_PLUGIN_CONTROL,2)==1) # if figures are visible
				##	close(h,"force");   # this function is missing in octave version before 4.2
				##	close("all","force");
				close(h); # if mode is normal and figures are visible, then close them after printing 
			endif
			P=[2;112;115;58]; #P= "\002ps:" - 002: DATA START
			g=fopen(TEXMACS_OCTAVE_TMP);
			while (g==-1)
				pause(0.2);
				g=fopen(TEXMACS_OCTAVE_TMP);
			endwhile
			f=fread(g);   # Lorenzo - read the whole file
			P=[P;f];
			fclose(g);
			P=[P;5]; # - 005: DATA END
			disp(sprintf("%cverbatim:\n",2));
			disp(char(P'));
			delete(TEXMACS_OCTAVE_TMP);
		endif
	endif
## ------------------- END TeXmacs Interface --------------------
endfunction
