## This software falls under the GNU general public license version 3 or later.
## It comes WITHOUT ANY WARRANTY WHATSOEVER. For details, see the file LICENSE
## in the root directory or <http://www.gnu.org/licenses/gpl-3.0.html>
## --  TeXmacs plotting interface -- tested with octave 4.2.1, 4.4.0, 4.4.1, 5.1.0
## This function load an octave figurein TeXmacs and close the figure window
## Author: Lorenzo Lunelli
## partly based on code from old TeXmacs plotting interface - Jan. 2003 -- Author: Michael Graffam
## v 0.3 Aug. 2018 initial version
## Nov 2019 v 0.4 - added Windows compatibility

function info = tmfig ()
## ------------------- TeXmacs Interface --------------------
	# Lorenzo - 21-08-2018 - check if interactive plotting mode is selected
	global TEXMACS_OCTAVE_PLUGIN_CONTROL;  # 28-August 2018: now using global variables
	global TEXMACS_OCTAVE_TMP; # 3-11-2019 added for windows compatibility
	message='';
	if (bitget(TEXMACS_OCTAVE_PLUGIN_CONTROL,1)==1)   # check bit 1 state (plotting mode)
		handle = gcf ();
		print(handle,TEXMACS_OCTAVE_TMP, "-deps", "-color");
##		close(handle,"force");   # this function is missing in octave version before 4.2
##		close("all","force");
		close(handle);
		P=[2;112;115;58]; #P= "\002ps:"
		g=fopen(TEXMACS_OCTAVE_TMP);
		while (g==-1)
			pause(0.2);
			g=fopen(TEXMACS_OCTAVE_TMP);
		endwhile
		f=fread(g);   # Lorenzo - read the whole file
		P=[P;f];
		fclose(g);
		P=[P;5];
		disp(sprintf("%cverbatim:\n",2));
		disp(char(P'));
		delete(TEXMACS_OCTAVE_TMP);
	else
		message="unsupported in normal plotting mode";
	endif
	info=message;
## ------------------- END TeXmacs Interface --------------------
endfunction
